import ddf.minim.*;
Minim minim;
AudioPlayer musique;

PImage imagePerso;
PImage imageTerrain;

final int sizeX=960; // terrain composé de 736 carré de 30*30 pixels. 32 carrés de long et 23 carrés de haut
final int sizeY=690;
final int tailleBriquesX=30;
final int tailleBriquesY=30;
final int taillePersoX=35;
final int taillePersoY=46;

final float accelerationPesanteur=0.4;
final float accelerationX=0.50;
final float limiteVitesseX=5;
final float hauteurJumps=-10;

int X=265;
int Y=300;
float vitesseDroiteX=0;
float vitesseGaucheX=0;
float vitesseY=0;


boolean toucheUP=false;
boolean toucheDOWN=false;
boolean toucheRIGHT=false;
boolean toucheLEFT=false;
boolean jumpFait=false;
int jumpConsecutifs=0;
int nombreMaxJumpsConsecutifs=100;

int briques[][][]= new int [23][4][2];

void initialiserTableauBriques() {

  briques[0][0][0]=1;  
  briques[0][0][1]=12;
  briques[0][1][0]=16; 
  briques[0][1][1]=17;
  briques[0][2][0]=21; 
  briques[0][2][1]=32;
  briques[0][3][0]=-1; 
  briques[0][3][1]=-1;

  briques[1][0][0]=1;  
  briques[1][0][1]=7;
  briques[1][1][0]=10; 
  briques[1][1][1]=12;
  briques[1][2][0]=21; 
  briques[1][2][1]=23;
  briques[1][3][0]=26; 
  briques[1][3][1]=32;

  briques[2][0][0]=1;  
  briques[2][0][1]=6;
  briques[2][1][0]=27; 
  briques[2][1][1]=32;
  briques[2][2][0]=-1; 
  briques[2][2][1]=-1;
  briques[2][3][0]=-1; 
  briques[2][3][1]=-1;

  briques[3][0][0]=1;  
  briques[3][0][1]=4;
  briques[3][1][0]=29; 
  briques[3][1][1]=32;
  briques[3][2][0]=-1; 
  briques[3][2][1]=-1;
  briques[3][3][0]=-1; 
  briques[3][3][1]=-1;

  briques[4][0][0]=1;  
  briques[4][0][1]=2;
  briques[4][1][0]=31; 
  briques[4][1][1]=32;
  briques[4][2][0]=-1; 
  briques[4][2][1]=-1;
  briques[4][3][0]=-1; 
  briques[4][3][1]=-1;

  briques[5][0][0]=1;  
  briques[5][0][1]=2;
  briques[5][1][0]=31; 
  briques[5][1][1]=32;
  briques[5][2][0]=-1; 
  briques[5][2][1]=-1;
  briques[5][3][0]=-1; 
  briques[5][3][1]=-1;

  briques[6][0][0]=1;  
  briques[6][0][1]=2;
  briques[6][1][0]=11; 
  briques[6][1][1]=22;
  briques[6][2][0]=31; 
  briques[6][2][1]=32;
  briques[6][3][0]=-1; 
  briques[6][3][1]=-1;

  briques[7][0][0]=1;  
  briques[7][0][1]=6;
  briques[7][1][0]=11; 
  briques[7][1][1]=12;
  briques[7][2][0]=21; 
  briques[7][2][1]=22;
  briques[7][3][0]=27; 
  briques[7][3][1]=32;

  briques[8][0][0]=1;  
  briques[8][0][1]=1;
  briques[8][1][0]=12; 
  briques[8][1][1]=12;
  briques[8][2][0]=21; 
  briques[8][2][1]=21;
  briques[8][3][0]=32; 
  briques[8][3][1]=32;

  briques[9][0][0]=1;  
  briques[9][0][1]=1;
  briques[9][1][0]=32; 
  briques[9][1][1]=32;
  briques[9][2][0]=-1; 
  briques[9][2][1]=-1;
  briques[9][3][0]=-1; 
  briques[9][3][1]=-1;

  briques[10][0][0]=7;  
  briques[10][0][1]=8;
  briques[10][1][0]=25; 
  briques[10][1][1]=26;
  briques[10][2][0]=-1; 
  briques[10][2][1]=-1;
  briques[10][3][0]=-1; 
  briques[10][3][1]=-1;

  briques[11][0][0]=-1; 
  briques[11][0][1]=-1;
  briques[11][1][0]=-1; 
  briques[11][1][1]=-1;
  briques[11][2][0]=-1; 
  briques[11][2][1]=-1;
  briques[11][3][0]=-1; 
  briques[11][3][1]=-1;

  briques[12][0][0]=-1; 
  briques[12][0][1]=-1;
  briques[12][1][0]=-1; 
  briques[12][1][1]=-1;
  briques[12][2][0]=-1; 
  briques[12][2][1]=-1;
  briques[12][3][0]=-1; 
  briques[12][3][1]=-1;

  briques[13][0][0]=1;  
  briques[13][0][1]=3;
  briques[13][1][0]=30; 
  briques[13][1][1]=32;
  briques[13][2][0]=-1; 
  briques[13][2][1]=-1;
  briques[13][3][0]=-1; 
  briques[13][3][1]=-1;

  briques[14][0][0]=1;  
  briques[14][0][1]=2;
  briques[14][1][0]=9;  
  briques[14][1][1]=11;
  briques[14][2][0]=22; 
  briques[14][2][1]=24;
  
  briques[14][3][0]=31; 
  briques[14][3][1]=32;

  briques[15][0][0]=1;  
  briques[15][0][1]=2;
  briques[15][1][0]=31; 
  briques[15][1][1]=32;
  briques[15][2][0]=-1; 
  briques[15][2][1]=-1;
  briques[15][3][0]=-1; 
  briques[15][3][1]=-1;

  briques[16][0][0]=1;  
  briques[16][0][1]=2;
  briques[16][1][0]=15; 
  briques[16][1][1]=18;
  briques[16][2][0]=31; 
  briques[16][2][1]=32;
  briques[16][3][0]=-1; 
  briques[16][3][1]=-1;

  briques[17][0][0]=1;  
  briques[17][0][1]=6;
  briques[17][1][0]=16; 
  briques[17][1][1]=17;
  briques[17][2][0]=27; 
  briques[17][2][1]=32;
  briques[17][3][0]=-1; 
  briques[17][3][1]=-1;

  briques[18][0][0]=1;  
  briques[18][0][1]=5;
  briques[18][1][0]=28; 
  briques[18][1][1]=32;
  briques[18][2][0]=-1; 
  briques[18][2][1]=-1;
  briques[18][3][0]=-1; 
  briques[18][3][1]=-1;

  briques[19][0][0]=1;  
  briques[19][0][1]=5;
  briques[19][1][0]=28; 
  briques[19][1][1]=32;
  briques[19][2][0]=-1; 
  briques[19][2][1]=-1;
  briques[19][3][0]=-1; 
  briques[19][3][1]=-1;

  briques[20][0][0]=1;  
  briques[20][0][1]=5;
  briques[20][1][0]=10; 
  briques[20][1][1]=12;
  briques[20][2][0]=21; 
  briques[20][2][1]=23;
  briques[20][3][0]=28; 
  briques[20][3][1]=32;

  briques[21][0][0]=1;  
  briques[21][0][1]=12;
  briques[21][1][0]=21; 
  briques[21][1][1]=32;
  briques[21][2][0]=-1; 
  briques[21][2][1]=-1;
  briques[21][3][0]=-1; 
  briques[21][3][1]=-1;

  briques[22][0][0]=1;  
  briques[22][0][1]=12;
  briques[22][1][0]=16; 
  briques[22][1][1]=17;
  briques[22][2][0]=21; 
  briques[22][2][1]=32;
  briques[22][3][0]=-1; 
  briques[22][3][1]=-1;
}


void blocsEtPlateformesBloquentPerso() {

  int hautCouloirHorizontal=Y;
  int basCouloirHorizontal=Y+taillePersoY;
  int gaucheCouloirvertical=X;
  int droiteCouloirVertical=X+taillePersoX;

  int nombreGeneralColonnesconcernees= int(taillePersoX/tailleBriquesX)+1;
  int nombreGeneralLignesconcernees= int(taillePersoY/tailleBriquesY)+1;

  int numeroPremiereColonneConcernee=int(X/tailleBriquesX)+1; //car colonnes de briques de 1 à 32
  int numeroDerniereColonneConcernee=int((X+taillePersoX)/tailleBriquesX)+1;
  int numeroPremiereLigneConcernee=int(Y/tailleBriquesY);// car lignes de briques de 0 à 22
  int numeroDerniereLigneConcernee=int((Y+taillePersoY)/tailleBriquesY);

if(numeroPremiereLigneConcernee<0 || numeroDerniereLigneConcernee>22){

}else{
  for (int i=0; i<4; i++) {
    if ((briques[numeroPremiereLigneConcernee][i][0]<=numeroPremiereColonneConcernee && briques[numeroPremiereLigneConcernee][i][1]>=numeroPremiereColonneConcernee) || (briques[numeroPremiereLigneConcernee][i][0]<=numeroDerniereColonneConcernee && briques[numeroPremiereLigneConcernee][i][1]>=numeroDerniereColonneConcernee)) {
      if ((briques[numeroPremiereLigneConcernee+1][i][0]<=numeroPremiereColonneConcernee && briques[numeroPremiereLigneConcernee+1][i][1]>=numeroPremiereColonneConcernee) || (briques[numeroPremiereLigneConcernee+1][i][0]<=numeroDerniereColonneConcernee && briques[numeroPremiereLigneConcernee+1][i][1]>=numeroDerniereColonneConcernee)) {
      } else {
        vitesseY=0;
        Y=(numeroPremiereLigneConcernee+1)*tailleBriquesY+1;
      }
    }
    if ((briques[numeroDerniereLigneConcernee][i][0]<=numeroPremiereColonneConcernee && briques[numeroDerniereLigneConcernee][i][1]>=numeroPremiereColonneConcernee) || (briques[numeroDerniereLigneConcernee][i][0]<=numeroDerniereColonneConcernee && briques[numeroDerniereLigneConcernee][i][1]>=numeroDerniereColonneConcernee)) {
      if ((briques[numeroDerniereLigneConcernee-1][i][0]<=numeroPremiereColonneConcernee && briques[numeroDerniereLigneConcernee-1][i][1]>=numeroPremiereColonneConcernee) || (briques[numeroDerniereLigneConcernee-1][i][0]<=numeroDerniereColonneConcernee && briques[numeroDerniereLigneConcernee-1][i][1]>=numeroDerniereColonneConcernee)) {
      } else { 
        vitesseY=0;
        Y=numeroDerniereLigneConcernee*tailleBriquesY-taillePersoY;
      }
    }
  }
  for ( int i=numeroPremiereLigneConcernee+1; i<numeroDerniereLigneConcernee; i++) {
    for (int j=0; j<4; j++) {
      if (briques[i][j][0]<=numeroPremiereColonneConcernee && briques[i][j][1]>=numeroPremiereColonneConcernee) {
        //if (briques[i][j][0]<=numeroPremiereColonneConcernee+1 && briques[i][j][1]>=numeroPremiereColonneConcernee+1) {
        //} else {
        //  if(abs(X-(numeroPremiereColonneConcernee*tailleBriquesX+1))<5){
          vitesseGaucheX=0;
          vitesseDroiteX=0;
          X=numeroPremiereColonneConcernee*tailleBriquesX+1;
        
      }
      if (briques[i][j][0]<=numeroDerniereColonneConcernee && briques[i][j][1]>=numeroDerniereColonneConcernee) {
        //if (briques[i][j][0]<=numeroDerniereColonneConcernee-1 && briques[i][j][1]>=numeroDerniereColonneConcernee-1) {} else {
        vitesseGaucheX=0;
        vitesseDroiteX=0;
        X=(numeroDerniereColonneConcernee-1)*tailleBriquesX-1-taillePersoX;
      }
    }
  }
}

}




void effetPesanteur() {
  if (Y+taillePersoY<sizeY) {
    vitesseY=vitesseY+accelerationPesanteur;
  }
}



//void recadrageConstantDuPerso() {

//  //boolean coinHautGauchePerso=false;
//  //boolean coinHautDroitPerso=false;
//  //boolean coinBasGauchePerso=false;
//  //boolean coinBasDroitPerso=false;

//  //for(int i=1-1;i<=23-1;i++){
//  // for (int j=1-1;j<=4-1;j++){
//  //   if ( (X> (briques[i][j][0]-1)*tailleBriquesX && X< briques[i][j][1]*tailleBriquesX) && (Y>i*tailleBriquesY && Y<(i+1)*tailleBriquesY) ){
//  //    coinHautGauchePerso=true; 
//  //   }
//  // }
//  //}

//  ///**
//  if (X+taillePersoX>sizeX) {
//    X=sizeX-taillePersoX;
//    vitesseDroiteX=0;
//    vitesseGaucheX=0;
//  }
//  if (X<0) {
//    X=0;
//    vitesseDroiteX=0;
//    vitesseGaucheX=0;
//  }
//  if (Y+taillePersoY>sizeY) {
//    Y=sizeY-taillePersoY;
//    vitesseY=0;
//  }
//  if (Y<0) {
//    Y=0;
//    vitesseY=0;
//  }
//  //**/
//}


//boolean dansBrique(){
//  if 
//return true;
////}

void effetDesTouches() {
  if (toucheUP) {
    if (jumpConsecutifs<nombreMaxJumpsConsecutifs) {
      if (!jumpFait) {
        vitesseY= hauteurJumps;
        jumpFait=true;
        jumpConsecutifs++;
      }
    }
  }
  if (toucheDOWN) {
  }

  if (toucheRIGHT && toucheLEFT) {
    vitesseDroiteX=0;
    vitesseGaucheX=0;
  } else {
    if (!toucheRIGHT) {
      if (vitesseDroiteX>0) {
        vitesseDroiteX=vitesseDroiteX-accelerationX;
        if (vitesseDroiteX<0) {
          vitesseDroiteX=0;
        }
      }
    } 
    if (!toucheLEFT) {
      if (vitesseGaucheX>0) {
        vitesseGaucheX=vitesseGaucheX-accelerationX;
        if (vitesseGaucheX<0) {
          vitesseGaucheX=0;
        }
      }
    } 
    if (toucheRIGHT) {
      if (vitesseDroiteX<limiteVitesseX) {
        vitesseDroiteX=vitesseDroiteX+accelerationX;
        if (vitesseDroiteX>limiteVitesseX) {
          vitesseDroiteX=limiteVitesseX;
        }
      }
    }
    if (toucheLEFT) {
      if (vitesseGaucheX<limiteVitesseX) {
        vitesseGaucheX=vitesseGaucheX+accelerationX;
        if (vitesseGaucheX>limiteVitesseX) {
          vitesseGaucheX=limiteVitesseX;
        }
      }
    }
  }
}

void passagesDeTourDeMap(){
  if(Y>=300 && Y+taillePersoY<=390){
    if(X<0){
      X=959;
    }
    if(X>960){
      X=1;
    }
    if(X+taillePersoX>960){
    image(imagePerso,X-960,Y);
    }
  }
  if((X>=360 && X+taillePersoX<=450) || (X>=510 && X+taillePersoX<=600)){
    if(Y<0){
      Y=689;
    }
    if(Y>690){
      Y=1;
    }
    if(Y+taillePersoY>690){
    image(imagePerso,X,Y-690);
    }
  }
  
  
  image(imagePerso,X,Y);
}


boolean toucheLeSol() {
  if (Y+taillePersoY==sizeY) {
    return true;
  } else {
    return false;
  }
}

void RAZjumpConsecutifs() {
  if (toucheLeSol()) {
    jumpConsecutifs=0;
  }
}

void setup() {
  size(960, 690);
  background(255);
  frameRate(100);

  initialiserTableauBriques();

  minim=new Minim(this);
  musique=minim.loadFile("Mii Channel Music.mp3");
  imagePerso=loadImage("Pickle.jpg");
  imageTerrain=loadImage("towerfall-ascension-dark-world-2.jpg");
  stroke(255,0,0);
  strokeWeight(0);
}

void draw() {

  effetPesanteur();
  
  blocsEtPlateformesBloquentPerso();
  effetDesTouches();

  Y=Y+int(vitesseY);
  X=X+int(vitesseDroiteX)-int(vitesseGaucheX);
  image(imageTerrain, 0, 0);
  passagesDeTourDeMap();

  //recadrageConstantDuPerso();
  
  
 // text(str(jumpConsecutifs)+" "+str(vitesseDroiteX)+" "+str(vitesseGaucheX)+" "+str(vitesseY), X, Y);
  line(X,Y,X,Y+taillePersoY);
  line(X,Y,X+taillePersoX,Y);
  line(X+taillePersoX,Y,X+taillePersoX,Y+taillePersoY);
  line(X,Y+taillePersoY,X+taillePersoX,Y+taillePersoY);
  for(int x=0;x<=960;x=x+30){
    line(x,0,x,690);
  }
  for(int y=0;y<=690;y=y+30){
    line(0,y,960,y);
  }
  RAZjumpConsecutifs();
}

void keyPressed() {
  switch(keyCode) {
  case UP:
    toucheUP=true;
    break;
  case DOWN : 
    toucheDOWN=true;
    break;
  case RIGHT:
    toucheRIGHT=true;
    break;
  case LEFT:
    toucheLEFT=true;
    break;
  }
}

void keyReleased() {
  switch(keyCode) {
  case UP:
    toucheUP=false;
    jumpFait=false;
    break;
  case DOWN : 
    toucheDOWN=false;
    break;
  case RIGHT:
    toucheRIGHT=false;
    break;
  case LEFT:
    toucheLEFT=false;
    break;
  }
}
